import { __decorate, __param } from 'tslib';
import { InjectionToken, Input, Component, ChangeDetectionStrategy, Optional, Inject, ɵɵdefineInjectable, ɵɵinject, Injectable, NgModule } from '@angular/core';
import { NgbActiveModal, NgbModal, NgbModalModule } from '@ng-bootstrap/ng-bootstrap';
import { CommonModule } from '@angular/common';

class NgxBootstrapDialogAlertDeafultOptions {
    constructor() {
        this.title = '';
        this.message = '';
        this.confirmButtonLabel = 'Confirm';
        this.confirmButtonClass = 'btn btn-primary';
        this.showConfirmButton = true;
        this.cancelButtonLabel = 'Cancel';
        this.cancelButtonClass = 'btn btn-secondary';
        this.showCancelButton = false;
        this.showCloseButtons = false;
        this.ngbModalOptions = null;
    }
}
class NgxBootstrapDialogConfirmDefaultOptions extends NgxBootstrapDialogAlertDeafultOptions {
    constructor() {
        super(...arguments);
        this.showCancelButton = true;
    }
}
const NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS = new InjectionToken('NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS');
const NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS = new InjectionToken('NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS');

let NgxBootstrapDialogComponent = class NgxBootstrapDialogComponent {
    constructor(activeModal) {
        this.activeModal = activeModal;
    }
    ngOnInit() { }
};
NgxBootstrapDialogComponent.ctorParameters = () => [
    { type: NgbActiveModal }
];
__decorate([
    Input()
], NgxBootstrapDialogComponent.prototype, "options", void 0);
NgxBootstrapDialogComponent = __decorate([
    Component({
        selector: 'ngx-ngx-bootstrap-dialog',
        template: "<div class=\"modal-header\">\n  <h4 class=\"modal-title\">{{ options.title }}</h4>\n  <button\n    type=\"button\"\n    class=\"btn-close close\"\n    aria-label=\"Close\"\n    (click)=\"activeModal.dismiss()\"\n    *ngIf=\"options.showCloseButton\"\n  >\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</div>\n\n<div *ngIf=\"options.message\" class=\"modal-body\">\n  {{ options.message }}\n</div>\n\n<div class=\"modal-footer\">\n  <button\n    type=\"button\"\n    class=\"btn-cancel\"\n    [ngClass]=\"options.cancelButtonClass\"\n    (click)=\"activeModal.dismiss()\"\n    *ngIf=\"options.showCancelButton\"\n  >\n    {{ options.cancelButtonLabel }}\n  </button>\n\n  <button\n    type=\"button\"\n    class=\"btn-confirm\"\n    [ngClass]=\"options.confirmButtonClass\"\n    (click)=\"activeModal.close()\"\n    *ngIf=\"options.showConfirmButton\"\n    ngbAutofocus\n  >\n    {{ options.confirmButtonLabel }}\n  </button>\n</div>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [""]
    })
], NgxBootstrapDialogComponent);

let NgxBootstrapDialogService = class NgxBootstrapDialogService {
    constructor(modal, globalAlertDefaultOptions, globalConfirmDefaultOptions) {
        this.modal = modal;
        this.globalAlertDefaultOptions = globalAlertDefaultOptions;
        this.globalConfirmDefaultOptions = globalConfirmDefaultOptions;
    }
    alert(options) {
        this.alertRef = this.dialog(NgxBootstrapDialogComponent, new NgxBootstrapDialogAlertDeafultOptions(), this.globalAlertDefaultOptions, options);
        return this.alertRef.result;
    }
    confirm(options) {
        this.confirmRef = this.dialog(NgxBootstrapDialogComponent, new NgxBootstrapDialogConfirmDefaultOptions(), this.globalConfirmDefaultOptions, options);
        return this.confirmRef.result;
    }
    dialog(content, defaultOptions, globalOptions, options) {
        options = Object.assign(Object.assign(Object.assign({}, defaultOptions), globalOptions), options);
        const dialogRef = this.modal.open(content, options.ngbModalOptions);
        dialogRef.componentInstance.options = options;
        return dialogRef;
    }
};
NgxBootstrapDialogService.ctorParameters = () => [
    { type: NgbModal },
    { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS,] }] },
    { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS,] }] }
];
NgxBootstrapDialogService.ɵprov = ɵɵdefineInjectable({ factory: function NgxBootstrapDialogService_Factory() { return new NgxBootstrapDialogService(ɵɵinject(NgbModal), ɵɵinject(NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS, 8), ɵɵinject(NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS, 8)); }, token: NgxBootstrapDialogService, providedIn: "root" });
NgxBootstrapDialogService = __decorate([
    Injectable({
        providedIn: 'root',
    }),
    __param(1, Optional()),
    __param(1, Inject(NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS)),
    __param(2, Optional()),
    __param(2, Inject(NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS))
], NgxBootstrapDialogService);

let NgxBootstrapDialogModule = class NgxBootstrapDialogModule {
};
NgxBootstrapDialogModule = __decorate([
    NgModule({
        imports: [CommonModule, NgbModalModule],
        declarations: [NgxBootstrapDialogComponent],
        providers: [NgxBootstrapDialogService],
        entryComponents: [NgxBootstrapDialogComponent],
    })
], NgxBootstrapDialogModule);

/*
 * Public API Surface of ngx-bootstrap-dialog
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxBootstrapDialogModule, NgxBootstrapDialogService, NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS as ɵb, NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS as ɵc, NgxBootstrapDialogComponent as ɵd };
//# sourceMappingURL=ngx-bootstrap-dialog.js.map
