import { __extends, __decorate, __assign, __param } from 'tslib';
import { InjectionToken, Input, Component, ChangeDetectionStrategy, Optional, Inject, ɵɵdefineInjectable, ɵɵinject, Injectable, NgModule } from '@angular/core';
import { NgbActiveModal, NgbModal, NgbModalModule } from '@ng-bootstrap/ng-bootstrap';
import { CommonModule } from '@angular/common';

var NgxBootstrapDialogAlertDeafultOptions = /** @class */ (function () {
    function NgxBootstrapDialogAlertDeafultOptions() {
        this.title = '';
        this.message = '';
        this.confirmButtonLabel = 'Confirm';
        this.confirmButtonClass = 'btn btn-primary';
        this.showConfirmButton = true;
        this.cancelButtonLabel = 'Cancel';
        this.cancelButtonClass = 'btn btn-secondary';
        this.showCancelButton = false;
        this.showCloseButtons = false;
        this.ngbModalOptions = null;
    }
    return NgxBootstrapDialogAlertDeafultOptions;
}());
var NgxBootstrapDialogConfirmDefaultOptions = /** @class */ (function (_super) {
    __extends(NgxBootstrapDialogConfirmDefaultOptions, _super);
    function NgxBootstrapDialogConfirmDefaultOptions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.showCancelButton = true;
        return _this;
    }
    return NgxBootstrapDialogConfirmDefaultOptions;
}(NgxBootstrapDialogAlertDeafultOptions));
var NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS = new InjectionToken('NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS');
var NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS = new InjectionToken('NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS');

var NgxBootstrapDialogComponent = /** @class */ (function () {
    function NgxBootstrapDialogComponent(activeModal) {
        this.activeModal = activeModal;
    }
    NgxBootstrapDialogComponent.prototype.ngOnInit = function () { };
    NgxBootstrapDialogComponent.ctorParameters = function () { return [
        { type: NgbActiveModal }
    ]; };
    __decorate([
        Input()
    ], NgxBootstrapDialogComponent.prototype, "options", void 0);
    NgxBootstrapDialogComponent = __decorate([
        Component({
            selector: 'ngx-ngx-bootstrap-dialog',
            template: "<div class=\"modal-header\">\n  <h4 class=\"modal-title\">{{ options.title }}</h4>\n  <button\n    type=\"button\"\n    class=\"btn-close close\"\n    aria-label=\"Close\"\n    (click)=\"activeModal.dismiss()\"\n    *ngIf=\"options.showCloseButton\"\n  >\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</div>\n\n<div *ngIf=\"options.message\" class=\"modal-body\">\n  {{ options.message }}\n</div>\n\n<div class=\"modal-footer\">\n  <button\n    type=\"button\"\n    class=\"btn-cancel\"\n    [ngClass]=\"options.cancelButtonClass\"\n    (click)=\"activeModal.dismiss()\"\n    *ngIf=\"options.showCancelButton\"\n  >\n    {{ options.cancelButtonLabel }}\n  </button>\n\n  <button\n    type=\"button\"\n    class=\"btn-confirm\"\n    [ngClass]=\"options.confirmButtonClass\"\n    (click)=\"activeModal.close()\"\n    *ngIf=\"options.showConfirmButton\"\n    ngbAutofocus\n  >\n    {{ options.confirmButtonLabel }}\n  </button>\n</div>\n",
            changeDetection: ChangeDetectionStrategy.OnPush,
            styles: [""]
        })
    ], NgxBootstrapDialogComponent);
    return NgxBootstrapDialogComponent;
}());

var NgxBootstrapDialogService = /** @class */ (function () {
    function NgxBootstrapDialogService(modal, globalAlertDefaultOptions, globalConfirmDefaultOptions) {
        this.modal = modal;
        this.globalAlertDefaultOptions = globalAlertDefaultOptions;
        this.globalConfirmDefaultOptions = globalConfirmDefaultOptions;
    }
    NgxBootstrapDialogService.prototype.alert = function (options) {
        this.alertRef = this.dialog(NgxBootstrapDialogComponent, new NgxBootstrapDialogAlertDeafultOptions(), this.globalAlertDefaultOptions, options);
        return this.alertRef.result;
    };
    NgxBootstrapDialogService.prototype.confirm = function (options) {
        this.confirmRef = this.dialog(NgxBootstrapDialogComponent, new NgxBootstrapDialogConfirmDefaultOptions(), this.globalConfirmDefaultOptions, options);
        return this.confirmRef.result;
    };
    NgxBootstrapDialogService.prototype.dialog = function (content, defaultOptions, globalOptions, options) {
        options = __assign(__assign(__assign({}, defaultOptions), globalOptions), options);
        var dialogRef = this.modal.open(content, options.ngbModalOptions);
        dialogRef.componentInstance.options = options;
        return dialogRef;
    };
    NgxBootstrapDialogService.ctorParameters = function () { return [
        { type: NgbModal },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS,] }] },
        { type: undefined, decorators: [{ type: Optional }, { type: Inject, args: [NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS,] }] }
    ]; };
    NgxBootstrapDialogService.ɵprov = ɵɵdefineInjectable({ factory: function NgxBootstrapDialogService_Factory() { return new NgxBootstrapDialogService(ɵɵinject(NgbModal), ɵɵinject(NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS, 8), ɵɵinject(NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS, 8)); }, token: NgxBootstrapDialogService, providedIn: "root" });
    NgxBootstrapDialogService = __decorate([
        Injectable({
            providedIn: 'root',
        }),
        __param(1, Optional()),
        __param(1, Inject(NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS)),
        __param(2, Optional()),
        __param(2, Inject(NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS))
    ], NgxBootstrapDialogService);
    return NgxBootstrapDialogService;
}());

var NgxBootstrapDialogModule = /** @class */ (function () {
    function NgxBootstrapDialogModule() {
    }
    NgxBootstrapDialogModule = __decorate([
        NgModule({
            imports: [CommonModule, NgbModalModule],
            declarations: [NgxBootstrapDialogComponent],
            providers: [NgxBootstrapDialogService],
            entryComponents: [NgxBootstrapDialogComponent],
        })
    ], NgxBootstrapDialogModule);
    return NgxBootstrapDialogModule;
}());

/*
 * Public API Surface of ngx-bootstrap-dialog
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxBootstrapDialogModule, NgxBootstrapDialogService, NGX_BOOTSTRAP_ALERT_DEFAULT_OPTIONS as ɵb, NGX_BOOTSTRAP_CONFIRM_DEFAULT_OPTIONS as ɵc, NgxBootstrapDialogComponent as ɵd };
//# sourceMappingURL=ngx-bootstrap-dialog.js.map
